# -*- coding:utf-8 -*-
"""
@author: yq
@time: 2024/1/2
@desc: 模型基类
"""
import pandas as pd
import abc

class ModelBase(metaclass=abc.ABCMeta):

    @abc.abstractmethod
    def train(self, data: pd.DataFrame):
        pass

    @abc.abstractmethod
    def predict_prob(self, x: pd.DataFrame):
        pass

    @abc.abstractmethod
    def predict(self, x: pd.DataFrame):
        pass
